using System;
using System.Threading;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using System.Data;
using System.Windows.Forms;

namespace KidSparkPainting
{
	/// <summary>
    /// ĵ
	/// </summary>
	public class DocDraw : System.Windows.Forms.Control
    {
        #region вб
        /// <summary>
        /// еĲģʽ
        /// enModePoint:        깤
        /// enModeLine:         Ǧʹ
        /// enModeChineseBrush: ձʹ
        /// </summary>
        public enum WHITEBOARD_DRAW_MODE 
        { 
            enModePoint,            //깤
            enModePencil,           //Ǧʹ
            enModeChineseBrush      //ձ
        };

        #endregion вб

        #region 
        private Point m_ptLineStart, m_ptLineEnd, m_ptLinePrev; //һߵǰ˺ͺ˴Ӷγһ
        private bool m_bMouseDown;  //갴µ״̬־
		private Bitmap  m_bmpSaved; //Ӱλͼͼ
		public	Bitmap  BitmapCanvas    //ҳΪͼƬʹ
		{
			get
			{
				return m_bmpSaved;
			}
		}

        public int PenSize = 3; //ʳߴ
        public Color Pen_Color = Color.Black; //ɫ

		private Graphics m_grfxBm;  //ͼ壬֮ͼڸϽе
		public WHITEBOARD_DRAW_MODE m_enDrawMode = WHITEBOARD_DRAW_MODE.enModeChineseBrush;  //浱ǰĻͼģʽ

        public enum PenWidthMode    //ʿģʽ
        {
            ThinPen,    //ϸʴ
            MiddlePen,  //бʴ
            ThickPen    //ֱʴ
        };

        public PenWidthMode penwidthmode;

        #endregion 

		public DocDraw()
		{
			m_ptLineStart = m_ptLineEnd = m_ptLinePrev = new Point(0,0);
			m_bMouseDown = false;

            Size sz = SystemInformation.PrimaryMonitorMaximizedWindowSize;  //ȡĬһʾ󻯴ڳߴ硣
			m_bmpSaved = new Bitmap (sz.Width, sz.Height);
			m_grfxBm = Graphics.FromImage(m_bmpSaved);  //ͼƬ
			UnlockWhiteBoardMouseEvents();  //Ӷ
        }

        #region Ҫ޸
        //ҪĺΪӶ¼
        public void UnlockWhiteBoardMouseEvents()
        {
            this.MouseDown += new MouseEventHandler(this.OnMouseDownHdlr);
            this.MouseMove += new MouseEventHandler(this.OnMouseMoveHdlr);
            this.MouseUp += new MouseEventHandler(this.OnMouseUpHdlr);
        }

        //Ҫĺػ
		protected override void OnPaint(PaintEventArgs e)
		{
			Graphics g = e.Graphics;
			g.DrawImage(m_bmpSaved, 0,0,m_bmpSaved.Width, m_bmpSaved.Height);
        }

        //걻
		protected void OnMouseDownHdlr(object sender, MouseEventArgs mea)
		{
		    Point pt = new Point(mea.X, mea.Y);
			WhenMouseDown(pt);
		}

        //ƶ
		protected void OnMouseMoveHdlr(object sender, MouseEventArgs mea)
		{
			Point pt = new Point(mea.X, mea.Y);
			WhenMouseMove(pt);
		}

        //̧
		protected void OnMouseUpHdlr(object sender, MouseEventArgs mea)
		{
			Point pt = new Point(mea.X, mea.Y);
			WhenMouseUp(pt);
        }

        #endregion Ҫ޸

        #region 걻¡˶̧Ķ
        //걻ʱĶ
		public void WhenMouseDown(Point pt)
		{
			switch (m_enDrawMode)
            {
                #region 깤
                case WHITEBOARD_DRAW_MODE.enModePoint:          //깤
                    m_ptLineStart.X = pt.X;
                    m_ptLineStart.Y = pt.Y;
                    m_ptLineEnd.X = pt.X;
                    m_ptLineEnd.Y = pt.Y;
                    m_bMouseDown = true;
                    break;
                #endregion 깤
                #region Ǧʹ
                case WHITEBOARD_DRAW_MODE.enModePencil:         //Ǧʹ
                    m_ptLineStart.X = m_ptLinePrev.X = pt.X;
                    m_ptLineStart.Y = m_ptLinePrev.Y = pt.Y;
                    m_bMouseDown = true;
                    break;
                #endregion Ǧʹ
                #region ձʹ
                case WHITEBOARD_DRAW_MODE.enModeChineseBrush:   //ձʹ
                    m_ptLineStart.X = m_ptLinePrev.X = pt.X;
                    m_ptLineStart.Y = m_ptLinePrev.Y = pt.Y;

                    Pen ChinesePn = new Pen(Pen_Color, PenSize);
                    Brush ChineseBrush = new SolidBrush(Pen_Color);
                    Graphics grfxChineseBrush = CreateGraphics();
                    grfxChineseBrush.DrawLine(ChinesePn, m_ptLineStart, pt);
                    grfxChineseBrush.FillEllipse(ChineseBrush, pt.X - (PenSize / 2), pt.Y - (PenSize / 2), PenSize, PenSize);
                    grfxChineseBrush.Dispose();

                    m_grfxBm.DrawLine(ChinesePn, m_ptLineStart, pt);
                    m_grfxBm.FillEllipse(ChineseBrush, pt.X - (PenSize / 2), pt.Y - (PenSize / 2), PenSize, PenSize);
                    m_bMouseDown = true;
					break;
                #endregion ձʹ
                #region Ĭ
                default:
					break;
                #endregion Ĭ
            }
		}
		
  		//˶ʱĶ
		public void WhenMouseMove(Point pt)
		{
			switch (m_enDrawMode)
            {
                #region 깤
                case WHITEBOARD_DRAW_MODE.enModePoint:          //깤
                    Point pointshubiao = new Point(pt.X, pt.Y);
                    Point oldPointshubiao = m_ptLineEnd;

                    if (!m_bMouseDown)
                    {
                        return;
                    }

                    m_ptLineEnd.X = pt.X;
                    m_ptLineEnd.Y = pt.Y;

                    ControlPaint.DrawReversibleFrame(
                        this.RectangleToScreen(DrawRectangle.GetNormalizedRectangle(m_ptLineStart, oldPointshubiao)),
                        Color.Black, FrameStyle.Dashed);

                    // Draw new selection rectangle
                    ControlPaint.DrawReversibleFrame(
                        this.RectangleToScreen(DrawRectangle.GetNormalizedRectangle(m_ptLineStart, pointshubiao)),
                        Color.Black, FrameStyle.Dashed);
                    break;
                #endregion 깤
                #region Ǧʹ
                case WHITEBOARD_DRAW_MODE.enModePencil:         //Ǧʹ
                    m_ptLineEnd.X = pt.X;
                    m_ptLineEnd.Y = pt.Y;
                    if (m_bMouseDown)
                    {
                        Pen pn = new Pen(Pen_Color, PenSize);
                        Graphics grfx = CreateGraphics();
                        grfx.DrawLine(pn, m_ptLinePrev, m_ptLineEnd);
                        grfx.Dispose();
                        //bitmap
                        m_grfxBm.DrawLine(pn, m_ptLinePrev, m_ptLineEnd);
                    }
                    m_ptLinePrev = m_ptLineEnd;
                    break;
                #endregion Ǧʹ
                #region ձʹ
                case WHITEBOARD_DRAW_MODE.enModeChineseBrush:   //ձʹ
                    m_ptLineEnd.X = pt.X;
                    m_ptLineEnd.Y = pt.Y;
                    if (m_bMouseDown)
                    {
                        Pen ChinesePn = new Pen(Pen_Color, PenSize);
                        Brush ChineseBrush = new SolidBrush(Pen_Color);
                        Graphics grfx = CreateGraphics();
                        grfx.DrawLine(ChinesePn, m_ptLinePrev, m_ptLineEnd);
                        grfx.FillEllipse(ChineseBrush, pt.X - (PenSize / 2), pt.Y - (PenSize / 2), PenSize, PenSize);
                        grfx.Dispose();

                        m_grfxBm.DrawLine(ChinesePn, m_ptLinePrev, m_ptLineEnd);
                        m_grfxBm.FillEllipse(ChineseBrush, pt.X - (PenSize / 2), pt.Y - (PenSize / 2), PenSize, PenSize);
                    }
                    m_ptLinePrev = m_ptLineEnd;
                    break;
                #endregion ձʹ
                #region Ĭ
                default:
                    break;
                #endregion Ĭ
            }
		}

        //걻̧ʱĶ
		public void WhenMouseUp(Point pt)
		{
			switch (m_enDrawMode)
			{
                #region 깤
                case WHITEBOARD_DRAW_MODE.enModePoint:          //깤
                    ControlPaint.DrawReversibleFrame(this.RectangleToScreen(
                        DrawRectangle.GetNormalizedRectangle(m_ptLineStart, m_ptLineEnd)), 
                        Color.Black, FrameStyle.Dashed);
                    m_bMouseDown = false;
                    break;
                #endregion 깤
                #region Ǧʹ
                case WHITEBOARD_DRAW_MODE.enModePencil:         //Ǧʹ
                    m_bMouseDown = false;
                    break;
                #endregion Ǧʹ
                #region ձʹ
                case WHITEBOARD_DRAW_MODE.enModeChineseBrush:   //ձʹ
                    m_bMouseDown = false;
                    break;
                #endregion ձʹ
                #region Ĭ
                default:
                    break;
                #endregion Ĭ
			}
        }

        #endregion 걻¡˶̧Ķ

        #region 巽

        //򻭲вͼƬ,
        public void InsertPic(Image piccy)
        {
            try
            {
                //Image piccy = Image.FromFile(picpath);
                Point[] piccyBounds = new Point[3];
                piccyBounds[0] = new Point(0, 0); // top left
                piccyBounds[1] = new Point(piccy.Width, 0); // top right
                piccyBounds[2] = new Point(0, piccy.Height); // bottom left

                Graphics grfx = CreateGraphics();
                grfx.DrawImage(piccy, piccyBounds);
                m_grfxBm.DrawImage(piccy, piccyBounds);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message.ToString());
            }
        }

        //ıʴ
        public void ChangePenWidth(PenWidthMode penwidthMode)
        {
            switch (penwidthMode)
            { 
                case PenWidthMode.ThinPen:      //ϸʴ
                    PenSize = 3;
                    break;
                case PenWidthMode.MiddlePen:    //еȱʴ
                    PenSize = 6;
                    break;
                case PenWidthMode.ThickPen:     //ʴ
                    PenSize = 9;
                    break;
                default:
                    break;
            }
        }

        //ıʴɫ
        public void ChangePenColor(Color pencolor)
        {
            Pen_Color = pencolor;
        }

        #endregion 巽

        #region ֪Ƿʹã
        private void InitializeComponent()
        {
            this.SuspendLayout();
            this.ResumeLayout(false);
        }
        #endregion ֪Ƿʹã
    }
}
